<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__dma" kind="group">
    <compoundname>group_hal_dma</compoundname>
    <title>DMA (Direct Memory Access)</title>
    <innerclass prot="public" refid="structcyhal__dma__cfg__t">cyhal_dma_cfg_t</innerclass>
    <innergroup refid="group__group__hal__results__dma">DMA HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__dma_1ga430c1e3ddedade3b6f7ef1f8532e665b" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_dma_direction_t</name>
        <enumvalue id="group__group__hal__dma_1gga430c1e3ddedade3b6f7ef1f8532e665ba86dedc0ee3d9bf091e9f936040e2066a" prot="public">
          <name>CYHAL_DMA_DIRECTION_MEM2MEM</name>
          <briefdescription>
<para>Memory to memory. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1gga430c1e3ddedade3b6f7ef1f8532e665baef4c3c201a805bc17ea57d8dcfe49f49" prot="public">
          <name>CYHAL_DMA_DIRECTION_MEM2PERIPH</name>
          <briefdescription>
<para>Memory to peripheral. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1gga430c1e3ddedade3b6f7ef1f8532e665ba1226b2af396731bd8b959c14924bb612" prot="public">
          <name>CYHAL_DMA_DIRECTION_PERIPH2MEM</name>
          <briefdescription>
<para>Peripheral to memory. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1gga430c1e3ddedade3b6f7ef1f8532e665ba6bb2146283e064542427ddffc2fbe0d7" prot="public">
          <name>CYHAL_DMA_DIRECTION_PERIPH2PERIPH</name>
          <briefdescription>
<para>Peripheral to peripheral. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_dma_direction_t: </bold><linebreak />Direction for DMA transfers.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="133" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" bodystart="127" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" line="128" />
      </memberdef>
      <memberdef id="group__group__hal__dma_1gad4507e9f3660b19e1ddc3085a96279e2" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_dma_event_t</name>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2a31943df9f42ee4e594f2701f9daf16af" prot="public">
          <name>CYHAL_DMA_NO_INTR</name>
          <initializer>= 0</initializer>
          <briefdescription>
<para>No interrupt. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2ae5ed3faaed4b314d6b7115016e4c2e73" prot="public">
          <name>CYHAL_DMA_TRANSFER_COMPLETE</name>
          <initializer>= 1 &lt;&lt; 0</initializer>
          <briefdescription>
<para>Indicates that a burst or full transfer has completed. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2aed1388898b5c44164b69c29226461c4f" prot="public">
          <name>CYHAL_DMA_SRC_BUS_ERROR</name>
          <initializer>= 1 &lt;&lt; 1</initializer>
          <briefdescription>
<para>Indicates that there is a source bus error. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2a28e6e742cdc81f90dc1a0af854edcfa2" prot="public">
          <name>CYHAL_DMA_DST_BUS_ERROR</name>
          <initializer>= 1 &lt;&lt; 2</initializer>
          <briefdescription>
<para>Indicates that there is a destination bus error. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2ac02b14f1884befe2fc3c736ca09b5063" prot="public">
          <name>CYHAL_DMA_SRC_MISAL</name>
          <initializer>= 1 &lt;&lt; 3</initializer>
          <briefdescription>
<para>Indicates that the source address is not aligned. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2aa975cfc15572bcde29d3b79771f3f69d" prot="public">
          <name>CYHAL_DMA_DST_MISAL</name>
          <initializer>= 1 &lt;&lt; 4</initializer>
          <briefdescription>
<para>Indicates that the destination address is not aligned. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2a5d44bed82a7ab60351ccdc8be3ccac85" prot="public">
          <name>CYHAL_DMA_CURR_PTR_NULL</name>
          <initializer>= 1 &lt;&lt; 5</initializer>
          <briefdescription>
<para>Indicates that the current descriptor pointer is null. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2ac6197710bf44a105b69558913826465e" prot="public">
          <name>CYHAL_DMA_ACTIVE_CH_DISABLED</name>
          <initializer>= 1 &lt;&lt; 6</initializer>
          <briefdescription>
<para>Indicates that the active channel is disabled. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2ad48347e72e87bd61c17fdab21128a0ef" prot="public">
          <name>CYHAL_DMA_DESCR_BUS_ERROR</name>
          <initializer>= 1 &lt;&lt; 7</initializer>
          <briefdescription>
<para>Indicates that there has been a descriptor bus error. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_dma_event_t: </bold><linebreak />Flags enum of DMA events.</para></briefdescription>
        <detaileddescription>
<para>Multiple events can be enabled. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="147" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" bodystart="136" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" line="137" />
      </memberdef>
      <memberdef id="group__group__hal__dma_1ga05291825b0a7c7b9a92373ec53342b7a" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_dma_transfer_action_t</name>
        <enumvalue id="group__group__hal__dma_1gga05291825b0a7c7b9a92373ec53342b7aa1d892969519c81dd0728bc5ea99c835e" prot="public">
          <name>CYHAL_DMA_TRANSFER_BURST</name>
          <briefdescription>
<para>A single burst is triggered and a transfer completion event will occur after the burst. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dma_1gga05291825b0a7c7b9a92373ec53342b7aac422419b0c70b168a56a7bedc2bc2dad" prot="public">
          <name>CYHAL_DMA_TRANSFER_FULL</name>
          <briefdescription>
<para>All bursts are triggered and a single transfer completion event will occur at the end of all of them. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_dma_transfer_action_t: </bold><linebreak />If burst_size is used, selects whether a single trigger of the channel transfers a single burst of burst_size or a full transfer of size length (that is, every burst is triggered).</para></briefdescription>
        <detaileddescription>
<para>This will also select when a trigger complete event will occur; after each burst or after the full transfer </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="157" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" bodystart="153" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" line="154" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__dma_1ga8d2fdb7ab4e9ba5367ef596ad42bbe3f" kind="typedef" prot="public" static="no">
        <type>void(*</type>
        <definition>typedef void(* cyhal_dma_event_callback_t) (void *callback_arg, cyhal_dma_event_t event)</definition>
        <argsstring>)(void *callback_arg, cyhal_dma_event_t event)</argsstring>
        <name>cyhal_dma_event_callback_t</name>
        <briefdescription>
<para>Event handler for DMA interrupts. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" bodystart="175" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dma.h" line="175" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_dma_init</definition>
        <argsstring>(cyhal_dma_t *obj, uint8_t priority, cyhal_dma_direction_t direction)</argsstring>
        <name>cyhal_dma_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>priority</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__dma_1ga430c1e3ddedade3b6f7ef1f8532e665b">cyhal_dma_direction_t</ref></type>
          <declname>direction</declname>
        </param>
        <briefdescription>
<para>Initialize the DMA peripheral. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a DMA object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority of this DMA operation relative to others. The number of priority levels which are supported is hardware dependent. All implementations define a <ref kindref="member" refid="group__group__hal__impl__dma_1ga81946da56dd6ba8afd28f6056b1d779a">CYHAL_DMA_PRIORITY_DEFAULT</ref> constant which is always valid. If supported, implementations will also define <ref kindref="member" refid="group__group__hal__impl__dma_1gaca50872208f80fb4625591afbaf79d70">CYHAL_DMA_PRIORITY_HIGH</ref>, <ref kindref="member" refid="group__group__hal__impl__dma_1ga0b9bf793bb1892836a901599c26fd698">CYHAL_DMA_PRIORITY_MEDIUM</ref>, and <ref kindref="member" refid="group__group__hal__impl__dma_1ga30998fd4febd3080e00922f969b08712">CYHAL_DMA_PRIORITY_LOW</ref>. The behavior of any other value is implementation defined. See the implementation-specific DMA documentation for more details. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">direction</parametername>
</parameternamelist>
<parameterdescription>
<para>The direction memory is copied </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="80" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" bodystart="45" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" line="45" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dma_1ga8c1bf16caa5d53cb129e5544da1c8b21" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_dma_free</definition>
        <argsstring>(cyhal_dma_t *obj)</argsstring>
        <name>cyhal_dma_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Free the DMA object. </para>        </briefdescription>
        <detaileddescription>
<para>Freeing a DMA object while a transfer is in progress (see <ref kindref="member" refid="group__group__hal__dma_1ga6f962c164fedb088dbd2a48e21550fd0">cyhal_dma_is_busy</ref>) is invalid.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The DMA object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="100" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" bodystart="82" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" line="82" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dma_1gad39f32ac4fada8bc9e757df0a22fcce4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_dma_configure</definition>
        <argsstring>(cyhal_dma_t *obj, const cyhal_dma_cfg_t *cfg)</argsstring>
        <name>cyhal_dma_configure</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__dma__cfg__t">cyhal_dma_cfg_t</ref> *</type>
          <declname>cfg</declname>
        </param>
        <briefdescription>
<para>Setup a DMA descriptor for specified resource. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The DMA object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">cfg</parametername>
</parameternamelist>
<parameterdescription>
<para>Configuration parameters for the transfer </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the configure request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="123" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" bodystart="102" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" line="102" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dma_1gaf57a2b19848478b6604e09a3ecc3fbfc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_dma_start_transfer</definition>
        <argsstring>(cyhal_dma_t *obj)</argsstring>
        <name>cyhal_dma_start_transfer</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Initiates DMA channel transfer for specified DMA object. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The DMA object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the start_transfer request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="146" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" bodystart="125" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" line="125" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dma_1ga6f962c164fedb088dbd2a48e21550fd0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_dma_is_busy</definition>
        <argsstring>(cyhal_dma_t *obj)</argsstring>
        <name>cyhal_dma_is_busy</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks whether a transfer is pending or running on the DMA channel. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The DMA object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>True if DMA channel is busy </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="169" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" bodystart="148" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" line="148" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dma_1gacbccbcab79700c9e17bc47c525967876" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_dma_register_callback</definition>
        <argsstring>(cyhal_dma_t *obj, cyhal_dma_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_dma_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__dma_1ga8d2fdb7ab4e9ba5367ef596ad42bbe3f">cyhal_dma_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register a DMA callback handler. </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__dma_1gad41941e505b20be164c389925e7a25dc">cyhal_dma_enable_event</ref> occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The DMA object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when an event triggers </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="179" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" bodystart="171" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" line="171" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dma_1gad41941e505b20be164c389925e7a25dc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_dma_enable_event</definition>
        <argsstring>(cyhal_dma_t *obj, cyhal_dma_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_dma_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__dma_1gad4507e9f3660b19e1ddc3085a96279e2">cyhal_dma_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure DMA event enablement. </para>        </briefdescription>
        <detaileddescription>
<para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__dma_1gacbccbcab79700c9e17bc47c525967876">cyhal_dma_register_callback</ref> will be called.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The DMA object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The DMA event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events. The priority from the most recent call will take precedence, i.e all events will have the same priority. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on interrupts, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="197" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" bodystart="181" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_dma.c" line="181" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>High level interface for interacting with the direct memory access (DMA). </para>    </briefdescription>
    <detaileddescription>
<para>The DMA driver allows for initializing and configuring a DMA channel in order to trigger data transfers to and from memory and peripherals. The transfers occur independently of the CPU and are triggered in software. Multiple channels are available with user-selectable priority and transfer characteristics.</para>
<para><heading level="1">Features</heading></para>
<para><itemizedlist>
<listitem><para>CPU independent memory access</para></listitem><listitem><para>Access to memory and peripherals</para></listitem><listitem><para>Multiple independent channels</para></listitem><listitem><para>Configurable transer sizes and bursts</para></listitem><listitem><para>Configurable priorities</para></listitem><listitem><para>Event completion notification</para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start</heading></para>
<para>See <ref kindref="member" refid="group__group__hal__dma_1subsection_dma_snippet_1">Snippet 1: Simple DMA initialization and transfer</ref> for a code snippet that sets up a DMA transfer to move memory from one location to another.</para>

<para><heading level="1">Code snippets</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Error handling code has been intentionally left out of snippets to highlight API usage.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Snippet 1: Simple DMA initialization and transfer</bold></para>
<para>The following snippet initializes a DMA channel and uses it to transfer a a single block of memory. The DMA channel is reserved by calling <ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>. It then needs to be configured with <ref kindref="member" refid="group__group__hal__dma_1gad39f32ac4fada8bc9e757df0a22fcce4">cyhal_dma_configure</ref> and then the transfer is started with <ref kindref="member" refid="group__group__hal__dma_1gaf57a2b19848478b6604e09a3ecc3fbfc">cyhal_dma_start_transfer</ref>.<linebreak />
 If the DMA channel is not needed anymore, it can be released by calling <ref kindref="member" refid="group__group__hal__dma_1ga8c1bf16caa5d53cb129e5544da1c8b21">cyhal_dma_free</ref></para><para><programlisting filename="dma.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref><sp />dma;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dma__cfg__t">cyhal_dma_cfg_t</ref><sp />cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcyhal__dma__cfg__t_1addcfd22935f15ed7fd86990afb2d8fe5">src_addr</ref><sp />=<sp />0x8000000,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Start<sp />from<sp />address</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.src_increment<sp />=<sp />1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Increment<sp />source<sp />by<sp />1<sp />word</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dst_addr<sp />=<sp />0x8001000,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Destination<sp />from<sp />address</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dst_increment<sp />=<sp />1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Increment<sp />destination<sp />by<sp />1<sp />word</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.transfer_width<sp />=<sp />32,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />32<sp />bit<sp />transfer</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.length<sp />=<sp />0x10,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Transfer<sp />64<sp />bytes<sp />(16<sp />transfers<sp />of<sp />4<sp />bytes)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.burst_size<sp />=<sp />0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Transfer<sp />everything<sp />in<sp />a<sp />single<sp />burst</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.action<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gga05291825b0a7c7b9a92373ec53342b7aac422419b0c70b168a56a7bedc2bc2dad">CYHAL_DMA_TRANSFER_FULL</ref>,<sp /><sp /></highlight><highlight class="comment">//<sp />Notify<sp />when<sp />everything<sp />is<sp />done</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Allocate<sp />the<sp />DMA<sp />channel<sp />for<sp />use<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>(&amp;dma,<sp /><ref kindref="member" refid="group__group__hal__impl__dma_1ga81946da56dd6ba8afd28f6056b1d779a">CYHAL_DMA_PRIORITY_DEFAULT</ref>,<sp /><ref kindref="member" refid="group__group__hal__dma_1gga430c1e3ddedade3b6f7ef1f8532e665ba86dedc0ee3d9bf091e9f936040e2066a">CYHAL_DMA_DIRECTION_MEM2MEM</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />channel<sp />for<sp />the<sp />upcoming<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gad39f32ac4fada8bc9e757df0a22fcce4">cyhal_dma_configure</ref>(&amp;dma,<sp />&amp;cfg);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Begin<sp />the<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gaf57a2b19848478b6604e09a3ecc3fbfc">cyhal_dma_start_transfer</ref>(&amp;dma);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />the<sp />DMA<sp />channel<sp />is<sp />no<sp />longer<sp />needed,<sp />it<sp />can<sp />be<sp />freed<sp />up<sp />for<sp />other<sp />uses<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__hal__dma_1ga6f962c164fedb088dbd2a48e21550fd0">cyhal_dma_is_busy</ref>(&amp;dma))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__dma_1ga8c1bf16caa5d53cb129e5544da1c8b21">cyhal_dma_free</ref>(&amp;dma);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para>

<para><bold>Snippet 2: Configuring the DMA channel based on memory requirements</bold></para>
<para><ref kindref="member" refid="group__group__hal__dma_1gad39f32ac4fada8bc9e757df0a22fcce4">cyhal_dma_configure</ref> can be used after DMA initialization to handle a variety of memory layouts.</para><para><programlisting filename="dma.c"><codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />BUFFER_SIZE<sp />(32)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />PERIPHERAL_FIFO_ADDR<sp />(0x4001000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref><sp />dma;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />buffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Allocate<sp />the<sp />DMA<sp />channel<sp />for<sp />transfering<sp />from<sp />memory<sp />to<sp />a<sp />peripheral<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>(&amp;dma,<sp /><ref kindref="member" refid="group__group__hal__impl__dma_1ga81946da56dd6ba8afd28f6056b1d779a">CYHAL_DMA_PRIORITY_DEFAULT</ref>,<sp /><ref kindref="member" refid="group__group__hal__dma_1gga430c1e3ddedade3b6f7ef1f8532e665baef4c3c201a805bc17ea57d8dcfe49f49">CYHAL_DMA_DIRECTION_MEM2PERIPH</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dma__cfg__t">cyhal_dma_cfg_t</ref><sp />cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcyhal__dma__cfg__t_1addcfd22935f15ed7fd86990afb2d8fe5">src_addr</ref><sp />=<sp />(uint32_t)buffer,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Start<sp />from<sp />address</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.src_increment<sp />=<sp />1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Increment<sp />source<sp />by<sp />1<sp />word</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dst_addr<sp />=<sp />PERIPHERAL_FIFO_ADDR,<sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Destination<sp />from<sp />address</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dst_increment<sp />=<sp />0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Don't<sp />increment<sp />the<sp />destination</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.transfer_width<sp />=<sp />32,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />32<sp />bit<sp />transfer</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.length<sp />=<sp />BUFFER_SIZE,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Transfer<sp />64<sp />bytes<sp />(16<sp />transfers<sp />of<sp />4<sp />bytes)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.burst_size<sp />=<sp />0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Transfer<sp />everything<sp />in<sp />a<sp />single<sp />burst</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.action<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gga05291825b0a7c7b9a92373ec53342b7aac422419b0c70b168a56a7bedc2bc2dad">CYHAL_DMA_TRANSFER_FULL</ref>,<sp /><sp /></highlight><highlight class="comment">//<sp />Notify<sp />when<sp />everything<sp />is<sp />done</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gad39f32ac4fada8bc9e757df0a22fcce4">cyhal_dma_configure</ref>(&amp;dma,<sp />&amp;cfg);</highlight></codeline>
</programlisting></para>

<para><bold>Snippet 3: Interrupts and retriggering DMA transfers</bold></para>
<para>DMA events like transfer complete or error events can be used to trigger a callback function. <linebreak />
 This snippet uses <ref kindref="member" refid="group__group__hal__dma_1gad39f32ac4fada8bc9e757df0a22fcce4">cyhal_dma_configure</ref> to break the full transfer into multiple bursts. This allows higher priority items access to the memory bus if necessary while the DMA operation is still in progress. It then uses <ref kindref="member" refid="group__group__hal__dma_1gad41941e505b20be164c389925e7a25dc">cyhal_dma_enable_event()</ref> to enable the transfer complete event to trigger the callback function registered by <ref kindref="member" refid="group__group__hal__dma_1gacbccbcab79700c9e17bc47c525967876">cyhal_dma_register_callback()</ref>.</para><para><programlisting filename="dma.c"><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />dma_event_callback(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg,<sp /><ref kindref="member" refid="group__group__hal__dma_1gad4507e9f3660b19e1ddc3085a96279e2">cyhal_dma_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(event);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref>*<sp />dma<sp />=<sp />(<ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref>*)callback_arg;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Do<sp />work<sp />specific<sp />to<sp />each<sp />burst<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />all<sp />bursts<sp />are<sp />complete,<sp />start<sp />another<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__hal__dma_1ga6f962c164fedb088dbd2a48e21550fd0">cyhal_dma_is_busy</ref>(dma))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__dma_1gaf57a2b19848478b6604e09a3ecc3fbfc">cyhal_dma_start_transfer</ref>(dma);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_dma_events()</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dma__t">cyhal_dma_t</ref><sp />dma;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dma__cfg__t">cyhal_dma_cfg_t</ref><sp />cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcyhal__dma__cfg__t_1addcfd22935f15ed7fd86990afb2d8fe5">src_addr</ref><sp />=<sp />0x8000000,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Start<sp />from<sp />address</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.src_increment<sp />=<sp />1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Increment<sp />source<sp />by<sp />1<sp />word</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dst_addr<sp />=<sp />0x8001000,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Destination<sp />from<sp />address</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dst_increment<sp />=<sp />1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Increment<sp />destination<sp />by<sp />1<sp />word</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.transfer_width<sp />=<sp />32,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />32<sp />bit<sp />transfer</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.length<sp />=<sp />0x10,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Transfer<sp />64<sp />bytes<sp />(16<sp />transfers<sp />of<sp />4<sp />bytes)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.burst_size<sp />=<sp />4,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Transfer<sp />4<sp />words<sp />a<sp />a<sp />time</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.action<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gga05291825b0a7c7b9a92373ec53342b7aa1d892969519c81dd0728bc5ea99c835e">CYHAL_DMA_TRANSFER_BURST</ref>,<sp /></highlight><highlight class="comment">//<sp />Notify<sp />when<sp />each<sp />burst<sp />is<sp />done</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Allocate<sp />the<sp />DMA<sp />channel<sp />for<sp />use<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>(&amp;dma,<sp /><ref kindref="member" refid="group__group__hal__impl__dma_1ga30998fd4febd3080e00922f969b08712">CYHAL_DMA_PRIORITY_LOW</ref>,<sp /><ref kindref="member" refid="group__group__hal__dma_1gga430c1e3ddedade3b6f7ef1f8532e665ba86dedc0ee3d9bf091e9f936040e2066a">CYHAL_DMA_DIRECTION_MEM2MEM</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />channel<sp />for<sp />the<sp />upcoming<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gad39f32ac4fada8bc9e757df0a22fcce4">cyhal_dma_configure</ref>(&amp;dma,<sp />&amp;cfg);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />an<sp />event<sp />callback<sp />handler<sp />and<sp />enable<sp />events<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__dma_1gacbccbcab79700c9e17bc47c525967876">cyhal_dma_register_callback</ref>(&amp;dma,<sp />&amp;dma_event_callback,<sp />&amp;dma);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__dma_1gad41941e505b20be164c389925e7a25dc">cyhal_dma_enable_event</ref>(&amp;dma,<sp /><ref kindref="member" refid="group__group__hal__dma_1ggad4507e9f3660b19e1ddc3085a96279e2ae5ed3faaed4b314d6b7115016e4c2e73">CYHAL_DMA_TRANSFER_COMPLETE</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gad822a466fc63847114add720ef84c83a">CYHAL_ISR_PRIORITY_DEFAULT</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Begin<sp />the<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__dma_1gaf57a2b19848478b6604e09a3ecc3fbfc">cyhal_dma_start_transfer</ref>(&amp;dma);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>